// author: Chuck Baker
// Version 7.0

var febeNameGuidxref = {};
var febeItemsSelectedCount = 0;
var febeItemsListedCount = 0;

function febeBuildList(){
//alert(febeAddons[FEBE_GUID].name)
//alert(febeExtensionsList[FEBE_GUID].name)
//febeProps(febeExtensionsList[FEBE_GUID])

	// Clear the list
	var theList = document.getElementById("febeExtList");
	var children = theList.childNodes;
	var n = children.length;
	// Clear existing items
	for (var i = 0; i < n; i++) {
		theList.removeChild(children[0]);
	}//for
	
	febeQuBuList();
	
	// Sort the list
	var sortArray = [];
	for(var i in febeExtensionsList){
//alert(febeExtensionsList[i].name+" : "+febeExtensionsList[i].isCompatible+"\n"+febeExtensionsList[i].type+"\n"+febeExtensionsList[i].ignore)
		if(febeExtensionsList[i].ignore == true) continue;
		if(febeExtensionsList[i].isPersona == true) continue;
		if(febeExtensionsList[i].isGlobal == true) continue;
		var type = febeExtensionsList[i].type;
		if(type != "extension" && type != "theme") continue;
		sortArray.push(febeExtensionsList[i].name);
	}//for
	sortArray.sort();

	for(var i in sortArray){
		var data = febeExtensionsList[febeNameGuidxref[sortArray[i]]];
		if(data.ignore == true) continue;
		var row = document.createElement('listitem');
		
		row.setAttribute('id', data.guid );
		row.setAttribute('type', "checkbox" );
		row.setAttribute('oncommand', "febeCountSelected(this)" );
		//var fxver = "(Fx ver "+data.Minversion+" - "+data.Maxversion+")";
		var fxver = "";
		row.setAttribute('label', data.name+"{"+data.version+"}  "+fxver );
		row.setAttribute('checked', "false" );
		if(data.type == "extension"){
			if(data.userDisabled){
				row.setAttribute('style', "color: grey;" );
			}else{
				row.setAttribute('style', "color: blue;" );
			}
		}else{
			row.setAttribute('style', "color: green;" );
		}//if
		if(data.isCompatible == false) row.setAttribute('style', "color: red;" );
		
		theList.appendChild( row );
		febeItemsListedCount++;
	}//for
	document.getElementById("febeSelectAllID").setAttribute("disabled","false");
	document.getElementById("febeDeselectAllID").setAttribute("disabled","false");
	febeItemsSelectedCount = 0;
	document.getElementById("febeQbuSelectedValueID").value = febeItemsSelectedCount;
	document.getElementById("febeQbuListedValueID").value = febeItemsListedCount;
	return true;
}//febeBuListWindow()

function febeSelect(bool){
  // Select/deselect all
	febeItemsSelectedCount = 0;
	for(var i in febeExtensionsList){
		var item = febeExtensionsList[i];
		if(item.ignore) continue;
		if(item.isGlobal) continue;
		var type = item.type;
		if(type != "extension" && type != "theme") continue;
		var item = document.getElementById(i);
		if(item){item.setAttribute("checked",bool);}
		if(bool)febeItemsSelectedCount++;
	}//for
	document.getElementById("febeQbuSelectedValueID").value = febeItemsSelectedCount;
}//febeSelect()

function febeCountSelected(which){
	var bool = which.checked;
	if(bool){
		febeItemsSelectedCount++;
	}else{
		febeItemsSelectedCount--;
	}//if
	document.getElementById("febeQbuSelectedValueID").value = febeItemsSelectedCount;
	return true;
}//febeCountSelected()

function febeSaveList(){

}//febeSaveList()

function febeQuBuList(){
  //Get a list of all installed extensions/themes
	febeExtensionsList = {};

	for(var guid in febeAddons){
			var ext = febeAddons[guid];
			febeExtensionsList[guid] = ext;
			febeNameGuidxref[ext.name] = guid; 
	}//for
}//febeQuBuList()

function febeQuickBu(){	
	var combined = document.getElementById("febeCreateSingleXPI").checked;
	var combinedName = document.getElementById("febeCreateSingleXPIname").value +".xpi";
	febeExBuDir = document.getElementById("febeQuickBuDir").value;
	if(combined){
		febeTmpDir = Components.classes["@mozilla.org/file/local;1"]
                     .createInstance(Components.interfaces.nsILocalFile);
		febeTmpDir.initWithPath(febeExBuDir);
		febeTmpDir.append("QBuTmp")
		if ((febeTmpDir.exists() && febeTmpDir.isDirectory())){febeTmpDir.remove(true);}
		febeTmpDir.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0777);
	}//if
	var cnt = 0;
	for(var i in febeExtensionsList){
		var item = febeExtensionsList[i];
		if(item.ignore) continue;
		if(item.isGlobal) continue;
		if(item.isPersona) continue;
		var type = item.type;
		if(type != "extension" && type != "theme") continue;

		var which = document.getElementById(i);
//alert(i+"\n"+item.name+"\n"+which+"\n"+type+"\n"+isGlobal)
		if(which.getAttribute("checked") != "true"){continue;}		
		var srcName = item.installlocation;
		var destDir = febeExBuDir;
		if(combined){destDir = febeTmpDir.path;}
		var febeExtBuName = item.buname;
		
		if(item.isXpi == true){	// Perform a straight copy for xpis
			febeCopyFile(item.installlocation,destDir,item.buname);
		}else{
			febeZip(item.installlocation,destDir,item.buname,false,false);	
		}//if
		cnt++;
	}//for
	if(cnt == 0){
		febeAlert(febeMsg[326]);
		return true;
	}//if
	if(combined){
		febeProfDir = Components.classes["@mozilla.org/file/directory_service;1"]
			.getService(Components.interfaces.nsIProperties)
			.get("ProfD", Components.interfaces.nsIFile);
		febeProfDir.append("extensions");
		febeProfDir.append(FEBE_GUID);
		febeProfDir.append("!install.rdf");
		var sourcefile = febeProfDir.path;
		var destDir = febeTmpDir.path;
		var dName = "install.rdf";
		febeCopyFile(sourcefile,destDir,dName);	// Copy the install.rdf for the combined package
		febeZip(febeTmpDir.path,febeExBuDir,combinedName);

		var tmp = febeMsg[218].replace(/%NUM%/,cnt);
		tmp = tmp.replace(/%FNAME%/,combinedName);
		febeAlert(tmp);
		febeTmpDir.remove(true);
	}else{
		var tmp = febeMsg[217].replace(/%NUM%/,cnt);
		febeAlert(tmp);
	}//if
	return true;
}//febeQuickBu()

function febeQuickBuLoad(){
	febeGetPrefs();
	febeSetMsgs();
	
	// FEBE options window must be closed
	var tmp = Cc["@mozilla.org/appshell/window-mediator;1"].getService(Ci.nsIWindowMediator);
	var optWin = tmp.getMostRecentWindow("febe:options");
	if(!!optWin){
		febeAlert(febeMsg[347]);
		return false;
	}//if
	
	febeGetAddonList();
	var qbuDir = febeMsg[216];
	var prefName = "extensions.febe.quickBuDir";
	if(febePrefs.prefHasUserValue(prefName)){
		qbuDir = febeGetUnicharPref(prefName);
	}else{
		var prefName = "extensions.febe.extBUdir";
		if(febePrefs.prefHasUserValue(prefName)){
			qbuDir =febeGetUnicharPref(prefName);
		}//if
	}//if
	document.getElementById("febeQuickBuDir").value = qbuDir;
	return true;
}//febeQuickBuLoad()

function febeCreateSingleXPIcheck(that){
	document.getElementById("febeCreateSingleXPIbox").hidden = !that.checked;
}//febeCreateSingleXPIcheck()

function febeQuickBuBrowse(){
  // Select Quick backup destinaton directory
	const nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"]
			 .createInstance(nsIFilePicker);
	fp.init(window, febeMsg[216], nsIFilePicker.modeGetFolder);
	fp.appendFilters(nsIFilePicker.filterAll | nsIFilePicker.filterText);

    // Set default directory to current backup directory
	var qbuDir = document.getElementById("febeQuickBuDir").value;
	var dd = Components.classes["@mozilla.org/file/local;1"]
			 .createInstance(Components.interfaces.nsILocalFile);
	dd.initWithPath(qbuDir);
	fp.displayDirectory = dd;

	var rv = fp.show();
	if (rv == nsIFilePicker.returnOK){
		rv = fp.file;
		qbuDir = rv.path;
		febeSetUnicharPref("extensions.febe.quickBuDir", qbuDir);
		document.getElementById("febeQuickBuDir").value = qbuDir;
	}//if
	return true;
}//febeQuickBuBrowse()
