// author: Chuck Baker
// Version 7.0

var Cc = Components.classes;
var Ci = Components.interfaces;
var FEBE_GUID = "{4BBDD651-70CF-4821-84F8-2B918CF89CA3}"  // GUID of this extension
var febePrefs = Cc["@mozilla.org/preferences-service;1"].getService(Ci.nsIPrefService).getBranch("");

function febeLoadResultsContent(){
  // Load page with content

	var FEBEdir = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
	FEBEdir.initWithPath(febeGetUnicharPref("extensions.febe.curProfDir"));
	//FEBEdir.append("extensions");
	//FEBEdir.append(FEBE_GUID);
	FEBEdir.append("FEBEresults.html");
	document.location = "file://"+FEBEdir.path;
}//febeLoadResultsContent()

function febeGetUnicharPref(prefName) {
  return febePrefs.getComplexValue(prefName, Ci.nsISupportsString).data;
}//febeGetUnicharPref()
