// author: Chuck Baker
// Version 7.0

febeSetMsgs();

/*
function febeVerifyExtension(){
alert("FEBE verify"+Application.storage.get("extensionsLoaded", false))
	// Verify all entries in the profile/extensions directory. 
	//   To pass validation, an entry must:
	//     (1)  Be a non-empty directory that is named with a proper GUID - either  {xxxxxxxx-xxxx-xxxx-xxxxxxxxxxxx}, or a pseudo-email: xxx@something.tld
	//     (2)  Contain a parsable 'install.rdf' file that identifies the add-on as either an extension (type 2) or theme (type 4)
	//  A 'staged' directory indicates there are add-ons pending install.
	
	//Application.storage.get("febeAddons",febeAddons);
//febeProps(febeAddons)
	febeAddons = window.arguments[0];
	//Application.storage.set("fixverifyerrors", false);	// Fix verify errors?
	febeVerifyExtensions();
	//if(Application.storage.get("fixverifyerrors", false)){febeVerifyExtensions();}	// Run again to fix
	return true;
}//function febeVerifyExtension(){
*/

function febeAdvancedLoad(){
	//febeGetAddonList();
	//setTimeout('febeVerifyExtension();',1000);
	//febeCheckAddonsList("febeAdvancedLoad()")
//alert("Leaving febeAdvancedLoad()")
}//febeAdvancedLoad()

function febeVerifyExtensions(){
  // All valid extensions must be listed in the addon manager.
	// Also check for pending installs
	//
	if(!febeCheckStatus()) return false;
	var VEDfebeAddons = Application.storage.get("febeAddons",febeAddons);;
/*
//alert(febeAddons)
	try{	// Check to see if addons list is loaded
		var tmp = febeAddons[FEBE_GUID];	// Should be defined if list is loaded
	}catch(e){
		febeGetAddonList();
	}//try/catch
*/
	window.document.title = febeMsg[237];
	//Application.storage.set("runningVerifyExtRoutine", true);
	//var fixIt = Application.storage.get("fixverifyerrors", false);
	var errCnt = 0;
	var extCnt = 0;

	for each(var i in VEDfebeAddons){
		var item = i;
		var eType = item.type;
		if(item.ignore == true) continue;
		if(item.isValid == false){
			if(item.name == "staged"){
				tmp = febeMsg[203];
			}else{
				tmp = febeMsg[226]+" "+item.guid+" "+febeMsg[220];
			}//if
			tmp += "<br/>";
			febeprt(tmp,"red");
			errCnt++;
			continue;
		}//if
		if(item.installlocationverified == false){
			tmp = "Could not find install location for "+item.name
			febepert(tmp,"red")
			errCnt++;
			continue;
		}//if
		var extIsDisabled = item.userDisabled;
		var extIcon = item.iconURL;
		if(extIsDisabled){extIcon = "chrome://febe/skin/disabled.png";}

		var tmp = "<img src='"+extIcon+"' ";
		tmp += "style='border: 0px solid ; width: 16px; height: 16px;'/>&nbsp;";
		tmp += item.guid+" <b>"+item.name+"</b>";
		if(extIsDisabled) tmp += " <i>(disabled)</i>";
		tmp += " - OK";

		switch(eType){
			case "extension":
				febeprt(tmp,"blue");
				febeprt(item.installlocation,"black")
				extCnt++;
				break;
			case "theme":
				febeprt(tmp,"green");	
				extCnt++;
				break;
			default:
				break;
		}//switch

	}//for
	if(errCnt != 0){
		var errCnt = 0;
		var extCnt = 0;

		var tmp = "<style>color: red; font-size: 15px;</style>";
		tmp += febeMsg[224] + "\n";
		tmp += "<style>color: purple; font-size: 15px;</style>"+febeMsg[225];
		Application.storage.set("alertsound", "failure");
		fixIt = febeConfirm(tmp);
		//Application.storage.set("fixverifyerrors", fixIt);
		if(fixIt == false){ 
			var tmp = "<p><b>"+febeMsg[327]+"</b></p>";
			febeprt(tmp,"red");
			return true;
		}//if
		var tmp = febeMsg[221];
		febeprt(tmp,"red");
		for each(var i in VEDfebeAddons){
			var item = i;
			if(item.ignore == true) continue;
			if(item.isValid == true) continue;
			if(febeDeleteInvalidExt(item.installlocation)){
				if(item.name == "staged"){
					var tmp = febeMsg[239]+"<br/>";
				}else{
					var tmp = item.guid+" "+febeMsg[220]+" "+febeMsg[227]+"<br/>";
				}//if
				febeprt(tmp,"purple");
				extCnt++;
				continue;
			}else{
				var tmp = febeMsg[222]+" "+item.guid;
				febeprt(tmp,"red");
				errCnt++;
			}//if
		}//for
		var tmp = "<p><b>"+febeMsg[305]+"</b></p>";
		febeprt(tmp,"red");
	}else{
		var tmp = febeMsg[223].replace("%CNT%",extCnt);  // All OK
		febeprt("<br/>"+tmp,"purple");
		febeAlert(tmp);
	}//if
	return true;
}//febeVerifyExtensions()

function febeExtInfo(extGuid){
	var unk = "??????";
	febeExtObj = new Object;
	AddonManager.getAddonByID(extGuid, function(addon){
		febeExtObj.version = addon.version;
		if(!febeExtObj.version){febeExtObj.version = unk;}
		febeExtObj.guid = addon.id;
		febeExtObj.name = addon.name;
		if(!febeExtObj.name){febeExtObj.name = unk;}
		febeExtObj.description = addon.description;
		if(!febeExtObj.description){febeExtObj.description = unk;}
		febeExtObj.homepageURL = addon.homepageURL;
		if(!febeExtObj.homepageURL){febeExtObj.homepageURL = unk;}
		febeExtObj.creator = addon.creator;
		if(!febeExtObj.creator){febeExtObj.creator = unk;}
		febeExtObj.isDisabled = addon.userDisabled;
		febeExtObj.isCompatible = addon.isCompatible;
		febeExtObj.iconURL = addon.iconURL;
		if(!febeExtObj.iconURL){febeExtObj.iconURL = "chrome://mozapps/skin/xpinstall/xpinstallItemGeneric.png";}
		var type = addon.type;
		switch(type){
			case "theme":
				febeExtObj.type = 1;
				break;
			case "extension":
				febeExtObj.type = 2;
				break;
			default:
				febeExtObj.type = 0;
				break;
			}//switch
			febeExtObj.notInstalled = false;
			if(!addon) febeExtObj.notInstalled = true;
		return febeExtObj;
	});
alert("febeExtInfo\n"+febeExtObj.name)
	return febeExtObj;
/*
id = {4BBDD651-70CF-4821-84F8-2B918CF89CA3}
version = 7.0beta1
type = extension
isCompatible = false
providesUpdatesSecurely = true
blocklistState = 0
appDisabled = true
optionsURL = chrome://febe/content/settings/febeOptions.xul
aboutURL = null
installDate = Wed Jun 16 2010 16:27:42 GMT-0700 (US Mountain Standard Time)
updateDate = Wed Jun 16 2010 17:05:44 GMT-0700 (US Mountain Standard Time)
iconURL = chrome://febe/skin/febe32x32.png
name = FEBE
description = Backup your Firefox data
creator = Chuck Baker
homepageURL = http://softwarebychuck.com/
developers = undefined
translators = www.babelzilla.org
contributors = Leszek(teo)Zyczkowski (pl-PL translation, XUL help, beta tester, options icons),Ish Rodriguez (graphic design),menet (fr-FR translation, beta tester),Piotr Chylinski (Toolbar icons and display logos)
screenshots = 
applyBackgroundUpdates = true
install = null
pendingUpgrade = [object Object]
scope = 1
pendingOperations = 18
permissions = 9
isActive = true
userDisabled = false
isCompatibleWith = function (aAppVersion, aPlatformVersion) {
    return aAddon.isCompatibleWith(aAppVersion, aPlatformVersion);
}
uninstall = function () {
    if (!(aAddon instanceof DBAddonInternal)) {
        throw new Error("Cannot uninstall an add-on that isn't installed");
    }
    if (aAddon.pendingUninstall) {
        throw new Error("Add-on is already marked to be uninstalled");
    }
    XPIProvider.uninstallAddon(aAddon);
}
cancelUninstall = function () {
    if (!(aAddon instanceof DBAddonInternal)) {
        throw new Error("Cannot cancel uninstall for an add-on that isn't installed");
    }
    if (!aAddon.pendingUninstall) {
        throw new Error("Add-on is not marked to be uninstalled");
    }
    XPIProvider.cancelUninstallAddon(aAddon);
}
findUpdates = function (aListener, aReason, aAppVersion, aPlatformVersion) {
    new UpdateChecker(aAddon, aListener, aReason, aAppVersion, aPlatformVersion);
}
hasResource = function (aPath) {
    var bundle = null;
    if (aAddon instanceof DBAddonInternal) {
        bundle = aAddon._sourceBundle = aAddon._installLocation.getLocationForID(aAddon.id);
    } else {
        bundle = aAddon._sourceBundle.clone();
    }
    if (bundle.isDirectory()) {
        bundle.append(aPath);
        return bundle.exists();
    }
    var zipReader = Cc['@mozilla.org/libjar/zip-reader;1'].createInstance(Ci.nsIZipReader);
    zipReader.open(bundle);
    var result = zipReader.hasEntry(aPath);
    zipReader.close();
    return result;
}
getResourceURL = function (aPath) {
    var bundle = null;
    if (aAddon instanceof DBAddonInternal) {
        bundle = aAddon._sourceBundle = aAddon._installLocation.getLocationForID(aAddon.id);
    } else {
        bundle = aAddon._sourceBundle.clone();
    }
    if (bundle.isDirectory()) {
        bundle.append(aPath);
        return Services.io.newFileURI(bundle).spec;
    }
    return buildJarURI(bundle, aPath).spec;
}

*/
  // Get extension info from extensions.rdf

  var rdfs = Cc["@mozilla.org/rdf/rdf-service;1"].getService(Ci.nsIRDFService);
                     
	var profileDir = Cc["@mozilla.org/file/directory_service;1"].getService(Ci.nsIProperties).get("ProfD", Ci.nsIFile);
	profileDir.append("extensions.rdf");
	
	// Fix for international characters
	var ioServ = Cc["@mozilla.org/network/io-service;1"].getService(Ci.nsIIOService);
	var fph = ioServ.getProtocolHandler("file").QueryInterface(Ci.nsIFileProtocolHandler);
	var srcFile = fph.getURLSpecFromFile(profileDir);
	
	var ds = rdfs.GetDataSourceBlocking(srcFile);
	
	// Use old method if something comes up undefined
	var em = Cc["@mozilla.org/extensions/manager;1"].getService(Ci.nsIExtensionManager);
	var ext = null;
	if (em.getItemForID){
		ext = em.getItemForID(extGuid);
	}else{
		ext = em.getItemList(extGuid, null, {})[0];
	}//if
	this.isInvalid = Boolean(false);
	if(!ext){
		var style = "<style>color: red;font-size: 12pt;</style>";
		var tmp = style+febeMsg[219].replace("%GUID%",extGuid)+"\n";
		if(!Application.storage.get("runningVerifyExtRoutine", false)){febeAlert(tmp);}
		this.isInvalid = Boolean(true);
		return false;
	}//if
	
	var subject = rdfs.GetResource("urn:mozilla:item:"+extGuid);
	var prefix = "http://www.mozilla.org/2004/em-rdf#";
	
  // Guid
	this.guid = extGuid;
	
  // Name
	var predicate = rdfs.GetResource(prefix + "name");
	var name = ds.GetTarget(subject, predicate, true);
	if(name){
		this.name = name.QueryInterface(Ci.nsIRDFLiteral).Value;
	}else{
		this.name = ext.name;
	}//if
	if(!this.name){this.name="(none)";}
	
  // Version
	var predicate = rdfs.GetResource(prefix + "version");
	var version = ds.GetTarget(subject, predicate, true);
	if(version){
		this.version = version.QueryInterface(Ci.nsIRDFLiteral).Value;
	}else{
		this.version = ext.version;
	}//if
	if(!this.version){this.version="(none)";}

  // Description
	var predicate = rdfs.GetResource(prefix + "description");
	var description = ds.GetTarget(subject, predicate, true);
	if(description){this.description = description.QueryInterface(Ci.nsIRDFLiteral).Value;}
	if(!this.description){this.description="(none)";}

  // Home Page URL
	var predicate = rdfs.GetResource(prefix + "homepageURL");
	var homepageURL = ds.GetTarget(subject, predicate, true);
	if(homepageURL){this.homepageURL = homepageURL.QueryInterface(Ci.nsIRDFLiteral).Value;}
	if(!this.homepageURL){this.homepageURL="";}

  // Creator
	var predicate = rdfs.GetResource(prefix + "creator");
	var creator = ds.GetTarget(subject, predicate, true);
	if(creator){this.creator = creator.QueryInterface(Ci.nsIRDFLiteral).Value;}
	if(!this.creator){this.creator="(none)";}

  // Disabled?
	var predicate = rdfs.GetResource(prefix + "userDisabled");
	var userDisabled = ds.GetTarget(subject, predicate, true);
	if(userDisabled){
		this.isDisabled = userDisabled.QueryInterface(Ci.nsIRDFLiteral).Value;
	}else{
		this.isDisabled = false;
	}//if

  // iconURL
	var predicate = rdfs.GetResource(prefix + "iconURL");
	var iconURL = ds.GetTarget(subject, predicate, true);
	if(iconURL){
		this.iconURL = iconURL.QueryInterface(Ci.nsIRDFLiteral).Value;
	}else{
		this.iconURL = ext.iconURL;
	}//if
	if(!this.iconURL){this.iconURL="chrome://mozapps/skin/xpinstall/xpinstallItemGeneric.png";}
	
  // minVersion
	this.minVersion = ext.minAppVersion;
	if(!this.minVersion){this.minVersion="(none)";}
	
  // maxVersion    
	this.maxVersion = ext.maxAppVersion;
	if(!this.maxVersion){this.maxVersion="(none)";}
	
  // installLocation
	var predicate = rdfs.GetResource(prefix + "installLocation");
	var installLocation = ds.GetTarget(subject, predicate, true);
	if(installLocation){this.installLocation = installLocation.QueryInterface(Ci.nsIRDFLiteral).Value;}
	if(!this.installLocation){this.installLocation="(none)";}
	
  // parseType
	var predicate = rdfs.GetResource(prefix + "type");
	var parseType = ds.GetTarget(subject, predicate, true);
	if(parseType){
		this.type = parseType.QueryInterface(Ci.nsIRDFInt).Value;
	}else{
		this.type = ext.type;
	}//if

  // internalName
	var predicate = rdfs.GetResource(prefix + "internalName");
	var internalName = ds.GetTarget(subject, predicate, true);
	if(internalName){this.internalName = internalName.QueryInterface(Ci.nsIRDFLiteral).Value;}
	if(!this.internalName){this.internalName="(none)";}
	
  // updateURL
	var predicate = rdfs.GetResource(prefix + "updateURL");
	var updateURL = ds.GetTarget(subject, predicate, true);
	if(updateURL){this.updateURL = updateURL.QueryInterface(Ci.nsIRDFLiteral).Value;}
	if(!this.updateURL){this.updateURL="(none)";}
	
  // optionsURL
	var predicate = rdfs.GetResource(prefix + "optionsURL");
	var optionsURL = ds.GetTarget(subject, predicate, true);
	if(optionsURL){this.optionsURL = optionsURL.QueryInterface(Ci.nsIRDFLiteral).Value;}
	if(!this.optionsURL){this.optionsURL="(none)";}
	
  // aboutURL
	var predicate = rdfs.GetResource(prefix + "aboutURL");
	var aboutURL = ds.GetTarget(subject, predicate, true);
	if(aboutURL){this.aboutURL = aboutURL.QueryInterface(Ci.nsIRDFLiteral).Value;}
	if(!this.aboutURL){this.aboutURL="(none)";}
	
  // availableUpdateURL
	var predicate = rdfs.GetResource(prefix + "availableUpdateURL");
	var availableUpdateURL = ds.GetTarget(subject, predicate, true);
	if(availableUpdateURL){this.availableUpdateURL = availableUpdateURL.QueryInterface(Ci.nsIRDFLiteral).Value;}
	if(!this.availableUpdateURL){this.availableUpdateURL="(none)";}
	
  // availableUpdateHash
	var predicate = rdfs.GetResource(prefix + "availableUpdateHash");
	var availableUpdateHash = ds.GetTarget(subject, predicate, true);
	if(availableUpdateHash){this.availableUpdateHash = availableUpdateHash.QueryInterface(Ci.nsIRDFLiteral).Value;}
	if(!this.availableUpdateHash){this.availableUpdateHash="(none)";}
	
  // availableUpdateVersion
	var predicate = rdfs.GetResource(prefix + "availableUpdateVersion");
	var availableUpdateVersion = ds.GetTarget(subject, predicate, true);
	if(availableUpdateVersion){this.availableUpdateVersion = availableUpdateVersion.QueryInterface(Ci.nsIRDFLiteral).Value;}
	if(!this.availableUpdateVersion){this.availableUpdateVersion="(none)";}
	
  // contributors
	var predicate = rdfs.GetResource(prefix + "contributor");
	var targets = ds.GetTargets(subject, predicate, true);
	var contributors = [];
	if(targets){
		while (targets.hasMoreElements()){
			var contributor = targets.getNext();
			if (contributor instanceof Ci.nsIRDFLiteral){
				contributors.push(contributor.Value);
			}//if
		}//while
		this.contributors = contributors;
	}//if
	return true;
}//febeExtInfo()


function febeDeleteInvalidExt(path){
	var aFile = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
	if (!aFile) return false;
	aFile.initWithPath(path);
	try{
		aFile.remove(true);
	}catch(e){
		Application.storage.set("alertsound", "failure");
		febeFatal(e,febeMsg[306]+"\n"+path);
		return false;
	}//try/catch
	return true;	
}//febeDeleteInvalidExt()

function febeprt(txt,color,size){
	// Display content in log window
	if(!color) color="black";
	if(!size) size = 12;
	var box = document.getElementById("messages");
	txt = "<span style='font-family: Courier New,Courier,monospace; font-size: "+size+"px; color: "+color+";'>"+txt+"<br></span>"
	if(box){
		box.contentDocument.write(txt);
		var scrollBox = box.contentWindow.document.body;
		scrollBox.scrollTop = scrollBox.scrollHeight - scrollBox.clientHeight;
	}//if
	return true;
}//febeprt()

function febeIsValidGUID(guid, mode){
  // Validate GUID
	var mask = " `!$%^&*()+=?,'\"";	// Invalid characters
	for (var i = 0; i < guid.length; i++){
		var c = guid.charAt(i);
		if(mask.indexOf(c) != -1 ){return false;};
	}//for
	
	// GUID format: {xxxxxxxx-xxxx-xxxx-xxxxxxxxxxxx}
	var re = /^(\{){0,1}[0-9a-fA-F]{8}\-[0-9a-fA-F]{4}\-[0-9a-fA-F]{4}\-[0-9a-fA-F]{4}\-[0-9a-fA-F]{12}(\}){0,1}$/
	var guidOK = Boolean(guid.match(re));

	// Email format (valid)  i.e., "something@domain.tld"
	var re = /^[A-Za-z0-9](([_\.\-]?[a-zA-Z0-9]+)*)@([A-Za-z0-9]+)(([\.\-]?[a-zA-Z0-9]+)*)\.([A-Za-z]{2,})$/
	var emailOK = Boolean(guid.match(re));
	
	// Email format (malformed) - No TLD
	var re = /^[A-Za-z0-9](([_\.\-]?[a-zA-Z0-9]+)*)@([A-Za-z0-9]+)(([\.\-]?[a-zA-Z0-9]+)*)$/	
	var malformedemailOK = Boolean(!guid.match(re));
	if(mode == "lenient"){malformedemailOK = true;}
	return Boolean(guidOK || emailOK || malformedemailOK);
}//febeIsValidGUID()